
var BLNK
var C0
var SET_PSI
var INTERSEC
var I_DAT
var DimTextHeight
var TextHeight

ObdVersion  = 5            // Standard >= Version 5
OBD_CLASSIC = 4
DTInfoType  = 0            // unknown
NewSubLayerGroup = { }

function DTCreateLengthAbsolute ( length, lengthname ) forward
function DTSetName              ( ele, elemname )      forward
function DTSetInVisible         ( ele )                forward
function DTMoveGroupToLayer     ( layer, elem )        forward
function DTCreateSubLayer       ( name, parent, status, blanked, colnumber ) forward

/* ====================================================================== */
/* Intern aufgerufene Funktionen                                          */
/* ====================================================================== */

function DTMakeNew_layer_spec_List (CView, LayerGroup)
    NewLSpecGroup = {}
    for LSpec in CView.layer_spec do
        Layer = LayerGroup where .el_1 = LSpec.el_3.name
        if len (Layer) > 0 then
           if (Layer.el_1.el_2 = 0) then
              CurrentLSpec = { false, false, LSpec.el_3 }
           else
              CurrentLSpec = { true, true, LSpec.el_3 }
           end
        else
           CurrentLSpec = { LSpec.el_1, LSpec.el_2, LSpec.el_3 }
        end
        NewLSpecGroup = NewLSpecGroup + { CurrentLSpec }
    end
    return (NewLSpecGroup)
end

function DTMakeNew_layer_spec_List_from_InvisibleObjectList (CView, LayerObjectGroup)
    NewLSpecGroup = {}
    LSpecInvisibleObjectGroup = LayerObjectGroup
    for LSpec in CView.layer_spec do
        if LSpec.el_3 in LSpecInvisibleObjectGroup then
              CurrentLSpec = { false, false, LSpec.el_3 }
              LSpecInvisibleObjectGroup = LSpecInvisibleObjectGroup + LSpec.el_3.list_layer    // add sublayer
        else
           CurrentLSpec = { LSpec.el_1, LSpec.el_2, LSpec.el_3 }
        end
        NewLSpecGroup = NewLSpecGroup + { CurrentLSpec }
    end
    return (NewLSpecGroup)
end

function DTCreateDimTextHeight ( height )
    DTHfound = false
    if valid (DimTextHeight) then
        DimTextHeightGroup = DimTextHeight where .el_1 = height
        if valid (DimTextHeightGroup) and len (DimTextHeightGroup) > 0 then
            DimTextHeightEle = DimTextHeightGroup.el_1.el_2
            if valid (DimTextHeightEle) then
                DTHfound = true
            end
        end
    else
        DimTextHeight = { }
    end
    if not DTHfound then
        Name = "DTH" + string (height)
        DimTextHeightEle = length_absolute ( height )
        DTSetName ( DimTextHeightEle, Name )
        DimTextHeight = DimTextHeight + { { height, DimTextHeightEle, Name } }
    end
    return (DimTextHeightEle)
end

/* ---------------------------------------------------------------------- */

function DTCreateTextHeight ( height )
    THfound = false
    if valid (TextHeight) then
        TextHeightGroup = TextHeight where .el_1 = height
        if valid (TextHeightGroup) and len (TextHeightGroup) > 0 then
            TextHeightEle = TextHeightGroup.el_1.el_2
            if valid (TextHeightEle) then
                THfound = true
            end
        end
    else
        TextHeight = { }
    end
    if not THfound then
        Name = "TH" + string (height)
        TextHeightEle = length_absolute ( height )
        DTSetName ( TextHeightEle, Name )
        TextHeight = TextHeight + { { height, TextHeightEle, Name } }
    end
    return (TextHeightEle)
end

/* ---------------------------------------------------------------------- */
function DTSetIgesInfo ( ele, name, entity, form, de_zeile, pd_zeile )
    if ObdVersion >= 5 then
        create_attrib(ele,"IGES_NAME",    name)
        create_attrib(ele,"IGES_ENTITY",  entity)
        create_attrib(ele,"IGES_FORM",    form)
        create_attrib(ele,"IGES_ZEILE_DE",de_zeile)
        create_attrib(ele,"IGES_ZEILE_PD",pd_zeile)
    else
        create_attrib(ele,"IGES_NAME")
        set_attrib   (ele,"IGES_NAME",name)
        create_attrib(ele,"IGES_ENTITY")
        set_attrib   (ele,"IGES_ENTITY",entity)
        create_attrib(ele,"IGES_FORM")
        set_attrib   (ele,"IGES_FORM",form)
        create_attrib(ele,"IGES_ZEILE_DE")
        set_attrib   (ele,"IGES_ZEILE_DE",de_zeile)
        create_attrib(ele,"IGES_ZEILE_PD")
        set_attrib   (ele,"IGES_ZEILE_PD",pd_zeile)
    end
end

/* ---------------------------------------------------------------------- */
function DTSetDxfInfo ( ele, name, zeile )
    if ObdVersion >= 5 then
        create_attrib(ele,"DXF_NAME", name)
        create_attrib(ele,"DXF_ZEILE",zeile)
    else
        create_attrib(ele,"DXF_NAME")
        set_attrib   (ele,"DXF_NAME", name)
        create_attrib(ele,"DXF_ZEILE")
        set_attrib   (ele,"DXF_ZEILE",zeile)
    end
end

/* ---------------------------------------------------------------------- */
function DTSetInfo ( ele, infogroup )
    if valid(ele) then
        NrOfInfos=len(infogroup)
        if NrOfInfos > 0 then
            if len(infogroup) = 5 then
                DTSetIgesInfo (ele, infogroup.el_1, infogroup.el_2, infogroup.el_3, infogroup.el_4, infogroup.el_5)
            else
                DTSetDxfInfo  (ele, infogroup.el_1, infogroup.el_2)
            end
        end
    end
end

/* ---------------------------------------------------------------------- */
function DTSetColor ( ele, colgroup )
    if len (colgroup) > 1 then
        color ( ele, colgroup )
    else
        if colgroup.el_1 > 0 then
            color ( ele, colgroup.el_1 )
        end
    end
end

/* ---------------------------------------------------------------------- */
function DTSetVisible ( ele, blanked )
    if blanked > 0 then
        DTSetInVisible({ele})
    end
end

/* ---------------------------------------------------------------------- */
function DTSetName ( ele, elemname )
    if valid (elemname) then
        if len (elemname) > 0 then
            name ( ele, elemname )
        end
    end
end

/* ---------------------------------------------------------------------- */
function DTGetBuildDate ( )
    if not valid (I_DAT) then
        if valid(program.build_date) then
            I_DAT=int(program.build_date)
        else
            I_DAT=951231
        end
    end
    return (I_DAT)
end

/* ---------------------------------------------------------------------- */
function DTSetNewTextlength ( ele, laenge )
   if laenge > 0 then
      akt_prop = ele.par_mode.data
      akt_lang = get_world_length_of_string(ele.s,ele.font,ele.h,akt_prop)
      if akt_lang > 0 then
         if valid (AKT_UNIT) then
            if AKT_UNIT = "inch" or AKT_UNIT = "INCH" then  // Einheit inch ?
               akt_lang = akt_lang / 25.4
            end
         end
         new_prop = akt_prop * laenge / akt_lang
         diff = abs (new_prop-akt_prop)
         if (diff>0.01) then
            propmodus = ele.list_parnode where .name = "mode"
            propmodus = propmodus.first
            new_modus = prop_absolute(new_prop)
            edit (propmodus, ele , new_modus)
         end
      end
   end
end

/* ---------------------------------------------------------------------- */
function DTCreateTolText (tolgroup)
    if len (tolgroup.el_1) > 0 then   // Passungsangabe
        tol = posttext_fit ( tolgroup.el_1 )
        return (tol)
    end
    if len (tolgroup.el_2) > 0 then   // MinisMax
        tol = posttext_minismax ( tolgroup.el_2 )
        return (tol)
    end
    if len (tolgroup.el_3) > 0 or len (tolgroup.el_4) > 0 then   // Min and/or Max
        tol = posttext_minandmax ( tolgroup.el_3, tolgroup.el_4 )
        return (tol)
    end
    if ObdVersion >= 5 then
        tol = posttext_pnul ()
    else
        tol = posttext_minismax ( "" )
    end
    return (tol)
end

/* ---------------------------------------------------------------------- */
function DTCreateTextPos (textposgroup)
    ele = coord_absolute ( { textposgroup.el_1, textposgroup.el_2 } )
    return (ele)
end

/* ---------------------------------------------------------------------- */
function DTCreatePosMeas (posgroup)
    ele = posmeas_length ({false, { (C0.x+(posgroup.el_1)*C0.cos-(posgroup.el_2)*C0.sin) (C0.y+(posgroup.el_1)*C0.sin+(posgroup.el_2)*C0.cos) (0.0) } } )
    return (ele)
end

/* ---------------------------------------------------------------------- */
function DTCheckMeasure (mass_id, masstext)
  if valid ( mass_id.dist ) then
    mzahl = real ( masstext )
    if not valid (mzahl) then return end
    realm = real ( mass_id.dist) 
    abw = mzahl - realm
    if abw < 0 then abw = abw * (-1) end
      if abw > 0.005 then
         PropNode = mass_id.type.p_control
         if ObdVersion > OBD_CLASSIC then
             NewVal = mass_id.par_control.alldata + {{"box_under", mzahl}}
         else
             NewVal = mass_id.par_control.alldata + {{"real_measure", mzahl}}
         end
         edit (PropNode, mass_id, NewVal) 
      end
  end
end

/* ---------------------------------------------------------------------- */
function DTGetSublayers (Elem)
SLGroup = {}
for i in Elem.value do
   LayerName = i.layer.name
   if (len (SLGroup) > 0) then
      if not (LayerName in SLGroup) then
         SLGroup = SLGroup + { i.layer }
      end
   else
      SLGroup = { i.layer }
   end
end
return (SLGroup)
end

/* ---------------------------------------------------------------------- */
function DTMoveElementsToSubLayer (ParentLayer, SubLayer, LayerStatus, ElemGroup)
   //`Create Sublayer ` [SubLayer.name] ` in Layer ` [ParentLayer.name] nl
   if not (ParentLayer in NewSubLayerGroup) then
      NewSubLayerGroup = NewSubLayerGroup + ParentLayer
   end
   NewSubLayer = DTCreateSubLayer ( SubLayer.name, ParentLayer, LayerStatus, "false", { ElemGroup.el_1.layer.color } )
   if not (NewSubLayer in NewSubLayerGroup) then
      NewSubLayerGroup = NewSubLayerGroup + NewSubLayer
   end
   //`Move following elements to this sublayer : ` [ElemGroup] nl
   move_set_to_layer(ElemGroup, NewSubLayer)
   // Maybe there is a group in this group
   for Elem in ElemGroup do
      if Elem.actual_type.name = "group" then
         DTMoveGroupToLayer (ParentLayer, Elem)
      end
   end
   return
end

/* ---------------------------------------------------------------------- */
function DTMoveGroupToLayer ( Layer, Group )
     //Layer = Group.layer
     //[Group.name] ` (` [Layer.name] `)` nl
     SubLayers = DTGetSublayers (Group)  // Alle Layer der Unterelemente ermitteln
     //`SubLayers : ` nl
     //for sl in SubLayers do [sl.name] sp 2 end nl   // Only print names of Sublayers
     for SubLayer in SubLayers do
        ElemsToChange = Group.value where .layer.name = SubLayer.name
        //`(` [SubLayer.name] `) ` [SubLayer] ` : ` [ElemsToChange] nl
        DTMoveElementsToSubLayer (Layer, SubLayer, "inactive", ElemsToChange)
     end
     return
end

/* ---------------------------------------------------------------------- */
function DTMakeInvisibleGroupsInvisible ()
   if program.language = "deutsch" then
      prompt ("Sohnelemente unsichtbarer Gruppen auf unsichtbare Sublayer verschieben")
   else
      prompt ("Now i move Sublements of invisible Groups to invisible sublayers")
   end
   show_status_percent (0)
   lgr = top.list_layer where .status = "inactive"
   LgrPlus = lgr
   NrInactivLayers = len (lgr)
   `Anzahl inaktiver Layer : ` [NrInactivLayers] nl
   ggr = top.list_group where .layer in lgr sort by .layer
   NrOfGroups = len (ggr)
   NrDone     = 0
   `Anzahl betroffener Gruppen : ` [NrOfGroups] nl
   for i in ggr do  // Schleife ueber alle betroffenen Gruppen
     DTMoveGroupToLayer (i.layer, i)
     NrDone = NrDone + 1
     show_status_percent (NrDone * 100 / NrOfGroups)
   end
   show_status_percent (100)
   prompt (" ")
end

/* ====================================================================== */
/* Funktionen, die vom Datatranslator in die AQL-Datei eingetragen werden */
/* ====================================================================== */

function DTSetInVisible ( ele )
    move_set_to_layer(ele,BLNK)
end

/* ====================================================================== */

function DTSetOBDVersion ( version )
    ObdVersion = version
end

/* ====================================================================== */
function DTSetWorld ( world )
    return (world)
end

/* ====================================================================== */
function DTGetWorld ( )
    if ObdVersion > OBD_CLASSIC then
        if empty (aql_argument_list) then
            first_worlds = top.list_world where .name="first_world"
            world = first_worlds.first
        else
            world = top.["el_"+aql_arg_1]
        end
    else
        if empty (aql_argument_list) then
            world = top.list_world.first
        else
            world=top.["el_"+aql_arg_1]
        end
    end
    return (world)
end

/* ====================================================================== */
function DTGetDefaultFont ()
    if ObdVersion > OBD_CLASSIC then
        BuildDate = DTGetBuildDate ()
        if BuildDate > 951231 or BuildDate < 900000 then
            if optional_set(application.o_text.p_font) then
                DefaultFont=get_optional(application.o_text.p_font)
            else
                DefaultFont="Helvetica"
            end
        else
            DefaultFont=""
        end
    else                      // OBD-Classic
        DefaultFont = 1
    end
    return (DefaultFont)
end

/* ====================================================================== */
function DTSetSessionDefaults ()
    update_mode(false)
    error_response ("continue")
    if ObdVersion > OBD_CLASSIC then
        BuildDate = DTGetBuildDate ()
        if BuildDate >= 960704 or BuildDate < 900000 then
            SET_PSI=true
            if optional_set(application.a_set_permitselfintersect.p_permit) then
                INTERSEC=get_optional(application.a_set_permitselfintersect.p_permit)
            else
                INTERSEC=false
            end
            set_permitselfintersect(true)
        else
            SET_PSI=false
        end
    end
end

/* ====================================================================== */
function DTRestoreSystemDefaults ()
    file <screen> error_output
    update_mode(true)
    if valid (SET_PSI) and SET_PSI then
        set_permitselfintersect(INTERSEC)
    end
end

/* ====================================================================== */
function DTCreateLengthAbsolute ( length, lengthname )
    if ObdVersion >= 5 then
        ele = length_abs ( length )
    else
        ele = length_absolute ( length )
    end
    DTSetName (ele, lengthname)
    return (ele)
end

/* ====================================================================== */
function DTCreateLengthSum ( length1, length2, lengthname )
    ele = length_sum ( length1, length2 )
    DTSetName (ele, lengthname)
    return (ele)
end

/* ====================================================================== */
function DTCreateLengthProd ( number, length, lengthname )
    ele = length_prod ( number, length )
    DTSetName (ele, lengthname)
    return (ele)
end

/* ====================================================================== */

function DTCreateAngleAbsolute ( angle, anglename )
    if ObdVersion >= 5 then
        ele = angle_abs ( angle )
    else
        ele = angle_absolute ( angle )
    end
    DTSetName (ele, anglename)
    return (ele)
end

/* ====================================================================== */

function DTCreateAngleSum ( angle1, angle2, anglename )
    ele = angle_sum ( angle1, angle2 )
    DTSetName (ele, anglename)
    return (ele)
end

/* ====================================================================== */

function DTCreateWorldFirstRota ( point, angle, scale )
    if ObdVersion >= 5 then
        COOR = coord_onpoint   ( point )
        ele  = world_firstrota ( COOR, angle, scale )
    else
        ele = world_onpoint ( point, scale )
    end
    return (ele)
end

/* ====================================================================== */

function DTCreateWorldRotaScale ( point, angle, xscale, yscale, deleted )
    ele  = world_rota_scale ( point, angle, xscale, yscale )
    if deleted > 0 then
        delete (ele)
    end
    return (ele)
end

/* ====================================================================== */

function DTCreateLayer ( name, status, colnumber )
    /* ele = layer_create ( string(name), string(status) ) */
    layerobj = top.list_layer where .name = name
    if valid (layerobj.el_1) then
        ele = layerobj.el_1 
        edit ( ele, , "active" )
    else
        if ObdVersion >= 5 then
           if status = "active" then
               ele = layer_create ( name, true )
           else
               ele = layer_create ( name, false )
           end
        else
           ele = layer_normal ( name, status, false )
        end
        DTSetColor ( ele, colnumber )
    end
    return (ele)
end

/* ====================================================================== */

function DTCreateSubLayer ( name, parent, status, blanked, colnumber )
    edit ( parent, , "active" )
    layerobj = parent.list_layer where .name = name
    if valid (layerobj.el_1) then
        ele = layerobj.el_1 
        edit ( ele, , "active" )
    else
        if ObdVersion >= 5 then
           if status = "active" then
               ele = layer_create ( name, true )
           else
               ele = layer_create ( name, false )
           end
        else
           ele = layer_normal ( name, status, false )
        end
        DTSetColor ( ele, colnumber )
    end
  //DTSetVisible ( ele, blanked )
    return (ele)
end

/* ====================================================================== */

function DTSetLayerStatusInViewports (LayerGroup, ListType)
   if ObdVersion >= 5 then
      ActiveViewports = program.list_viewports

      for ActiveViewport in ActiveViewports do
          CView = ActiveViewport.corresponding_view
          xdir  = CView.dir.x
          ydir  = CView.dir.y
          zdir  = CView.dir.z
          lbx   = CView.left_bottom.x
          lby   = CView.left_bottom.y
          lbz   = CView.left_bottom.z
          rbx   = CView.right_bottom.x
          rby   = CView.right_bottom.y
          rbz   = CView.right_bottom.z
          ltx   = CView.left_top.x
          lty   = CView.left_top.y
          ltz   = CView.left_top.z

          if ListType = 1 then
              NewLayerSpec = DTMakeNew_layer_spec_List ( CView, LayerGroup )
          else
              NewLayerSpec = DTMakeNew_layer_spec_List_from_InvisibleObjectList ( CView, LayerGroup )
          end

          if valid (NewLayerSpec) then
             edit (    CView,
                   { { xdir, ydir, zdir},                    // viewdir
                     { lbx,  lby,  lbz },                    // left bottom
                     { rbx,  rby,  rbz },                    // right bottom
                     { ltx,  lty,  ltz },                    // left top
                       CView.vp_type,                        // viewporttype
                       CView.model,                          // model
                       NewLayerSpec,                         // New Layerspec's
                       CView.vis_meth_spec,                  // visualisation
                       application.v_vp_options_rec,         // options
                     { true, false, false, 0 } 
                   } )                                       //end of edit
          end
      end
   else                   // classic
      // don't know how to change Layerstatus
   end
end

/* ====================================================================== */

function DTSetLayerStatus (LayerGroup)
   DTSetLayerStatusInViewports (LayerGroup, 1)          // Set layers invisible
   DTMakeInvisibleGroupsInvisible ()
   DTSetLayerStatusInViewports (NewSubLayerGroup, 2)    // Set new Sublayers invisible
end

/* ====================================================================== */
function DTCreatePointOrigin ( world, pointname )
    ele = point_origin ( world )
    DTSetName ( ele, pointname )
    return (ele)
end

/* ====================================================================== */
function DTCreatePointRelative ( refpoint, x, y, blanked, colnumber, infogroup )
    ele = point_relative  ( refpoint, x, y )
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreatePointSameX ( refpoint, y, blanked, colnumber, infogroup )
    ele = point_samex  ( refpoint, y )
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreatePointSameY ( refpoint, x, blanked, colnumber, infogroup )
    ele = point_samey  ( refpoint, x )
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreateLine ( z, linestylegroup, ap, ep, blanked, colnumber, infogroup )
    ele = line_pointpoint ( z, linestylegroup, "is_limited", ap, ep )
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreateLineAngleLength ( z, linestylegroup, ap, angle, length, blanked, colnumber, infogroup )
    ele = line_pointalfalength ( z, linestylegroup, "is_limited", ap, angle, length, "beginv" )
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreateEndlessLineAngle ( z, linestylegroup, ap, angle, blanked, colnumber, infogroup )
    ele = line_pointalfalength ( z, linestylegroup, "not_limited", ap, angle, 100.0, "beginv" )
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreateArc ( z, linestylegroup, axes, p1, p2, p3, blanked, colnumber, infogroup )
    ele = circle_points3 ( z, linestylegroup, axes, "is_arc", "over_p2", p1, p2, p3 )
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreateCircle ( z, linestylegroup, axes, mp, radius, blanked, colnumber, infogroup )
    ele = circle_centerradius ( z, linestylegroup, axes, mp, radius )
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreateEllipse ( z, linestylegroup, axes, mp, pax1, pax2, blanked, colnumber, infogroup )
    ele = ellips_conjuncted_axes (z, linestylegroup, axes, mp, pax1, pax2)
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreateEllipseArc ( z, linestylegroup, axes, pm, pax1, pax2, pa, pe, blanked, colnumber, infogroup )
    el1 = ellips_conjuncted_axes (z, linestylegroup, axes, pm, pax1, pax2)
    DTSetInfo    ( el1, infogroup )
    ele = ellips_arc2points (z, linestylegroup, axes, el1, pa, pe)
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreateTextAbsolute ( font, italic, prop, mirror, textpos, text, ap, height, length, blanked, colnumber, infogroup )
    Theight = DTCreateTextHeight (height)
    if ObdVersion >= 5 then
        ele = text_absolute ( font, italic, prop, mirror, textpos, text, ap, Theight )
        DTSetNewTextlength  ( ele, length )
    else                                   // Classic
        ele = text_absolute ( TEXTFONT, text, ap, Theight )
    end
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreateTextAnglepos ( font, italic, prop, mirror, textpos, text, ap, height, angle, length, blanked, colnumber, infogroup )
    Theight = DTCreateTextHeight (height)
    if ObdVersion >= 5 then
        ele = text_anglepos ( font, italic, prop, mirror, textpos, text, ap, Theight, angle )
        DTSetNewTextlength  ( ele, length )
    else                                   // Classic
        ele = text_anglepos ( TEXTFONT, text, ap, Theight, angle, "beginv" )
    end
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreateTextBlock ( font, italic, prop, mirror, textpos, textgroup, ap, height, angle, length, blanked, colnumber, infogroup )
    Theight = DTCreateTextHeight (height)
    if ObdVersion >= 5 then
        ele = text_block ( font, italic, prop, mirror, textpos, ap, textgroup, Theight, angle )
//        DTSetNewTextlength  ( ele, length )
    else                                   // Classic
        ele = text_block ( font, ap, textgroup, Theight )
    end
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreateContourOfElements ( z, elemgroup, blanked, colnumber, infogroup )
    ele = contour_ofelements (  z, elemgroup )
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreateContourUnion ( z, contgroup, blanked, colnumber, infogroup )
    ele = contour_union (  z, contgroup )
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreateSymbolComment ( font, italic, prop, height, arrowtype, textangle, text, start, sel, bend, end, txpos, blanked, colnumber, infogroup )
    ele = symbol_comment ( font, italic, prop, height, arrowtype, textangle, text, start, sel, bend, end, txpos )
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreateSymbolForm ( font, italic, prop, height, symbol, toleranz, relationtextgroup, start, bend, frame, blanked, colnumber, infogroup )
    ele = symbol_form ( font, italic, prop, height, symbol, toleranz, relationtextgroup, start, bend, frame )
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
//function DTCreateRadiusDimension ( control_set, textgroup, tolgroup, font, italic, prop, height, pos, textpos, shortlong, circle, blanked, colnumber, infogroup )
function DTCreateRadiusDimension ( control_set, textgroup, tolgroup, pos, shortlong, arrowgroup, circle, blanked, colnumber, infogroup )
    toltext = DTCreateTolText ( tolgroup )
    textpos = textgroup.el_5
    tpos    = DTCreateTextPos ( textpos  )
    posmeas = DTCreatePosMeas ( pos )
    font    = textgroup.el_4.el_1
    italic  = textgroup.el_4.el_4
    prop    = textgroup.el_4.el_5
    height  = DTCreateDimTextHeight ( textgroup.el_4.el_2 )
    
    if ObdVersion >= 5 then
        ele = measure_radiusofsect ( control_set, textgroup.el_2, toltext, textgroup.el_3, font, italic, prop, height, tpos, shortlong, circle, posmeas )
    else
        ele = measure_radiusofsect ( control_set, textgroup.el_2, toltext, textgroup.el_3, height, tpos, shortlong, circle, posmeas )
    end
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    DTCheckMeasure ( ele, textgroup.el_1 )
    return (ele)
end

/* ====================================================================== */
//function DTCreateLinearDimension ( type, control_set, textgroup, tolgroup, font, italic, prop, height, pos, textpos, projection, plc1, plc2, sel, blanked, colnumber, infogroup )
function DTCreateLinearDimension ( type, control_set, textgroup, tolgroup, pos, projection, arrowgroup, plc1, plc2, sel, blanked, colnumber, infogroup )
    toltext = DTCreateTolText ( tolgroup )
    textpos = textgroup.el_5
    tpos    = DTCreateTextPos ( textpos  )
    posmeas = DTCreatePosMeas ( pos )
    font    = textgroup.el_4.el_1
    italic  = textgroup.el_4.el_4
    prop    = textgroup.el_4.el_5
    height  = DTCreateDimTextHeight ( textgroup.el_4.el_2 )
    if ObdVersion >= 5 then
        switch type
        case "plc1plc2":
             lagewinkel = projection
        case "pointpointvert":
             lagewinkel = 90.0
        case "pointpointhor":
             lagewinkel = 0.0
        end
        ele = measure_plc1plc2 ( control_set, textgroup.el_2, toltext, textgroup.el_3, font, italic, prop, height, lagewinkel, tpos, plc1, plc2, posmeas, sel )
    else
        switch type
        case "plc1plc2":
             ele = measure_plc1plc2 ( control_set, textgroup.el_2, toltext, textgroup.el_3, font, italic, prop, height, tpos, plc1, plc2, posmeas, sel )
        case "pointpointvert":
             ele = measure_pointpointvert ( control_set, textgroup.el_2, toltext, textgroup.el_3, height, tpos, plc1, plc2, posmeas, sel )
        case "pointpointhor":
             ele = measure_pointpointhor ( control_set, textgroup.el_2, toltext, textgroup.el_3, height, tpos, plc1, plc2, posmeas, sel )
        end
    end
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    DTCheckMeasure ( ele, textgroup.el_1 )
    return (ele)
end

/* ====================================================================== */
//function DTCreateDiameterDimension ( control_set, textgroup, tolgroup, font, italic, prop, height, pos, textpos, lagewinkel, pc1, blanked, colnumber, infogroup )
function DTCreateDiameterDimension ( control_set, textgroup, tolgroup, pos, lagewinkel, arrowgroup, pc1, blanked, colnumber, infogroup )
    toltext = DTCreateTolText ( tolgroup )
    textpos = textgroup.el_5
    tpos    = DTCreateTextPos ( textpos  )
    posmeas = DTCreatePosMeas ( pos )
    font    = textgroup.el_4.el_1
    italic  = textgroup.el_4.el_4
    prop    = textgroup.el_4.el_5
    height  = DTCreateDimTextHeight ( textgroup.el_4.el_2 )
    if ObdVersion >=5 then
        ele = measure_diamofcircle ( control_set, textgroup.el_2, toltext, textgroup.el_3, font, italic, prop, height, lagewinkel, tpos, pc1, posmeas )
    else
        ele = measure_diamofcircle ( control_set, textgroup.el_2, toltext, textgroup.el_3, height, tpos, pc1, lagewinkel, posmeas )
    end
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    DTCheckMeasure ( ele, textgroup.el_1 )
    return (ele)
end

/* ====================================================================== */
//function DTCreateAngularDimension ( type, control_set, textgroup, tolgroup, font, italic, prop, height, pos, textpos, longshort, plgroup, sel, blanked, colnumber, infogroup )
function DTCreateAngularDimension ( type, control_set, textgroup, tolgroup, pos, longshort, arrowgroup, plgroup, sel, blanked, colnumber, infogroup )
    toltext = DTCreateTolText ( tolgroup )
    textpos = textgroup.el_5
    tpos    = DTCreateTextPos ( textpos  )
    posmeas = DTCreatePosMeas ( pos )
    font    = textgroup.el_4.el_1
    italic  = textgroup.el_4.el_4
    prop    = textgroup.el_4.el_5
    height  = DTCreateDimTextHeight ( textgroup.el_4.el_2 )
    if ObdVersion >=5 then
       if valid (font) then
          UsedFont = font
       else
          UsedFont = DTGetDefaultFont ()
       end
       switch type
       case "angle2lines":
             ele = measure_angle2lines  ( control_set, textgroup.el_2, toltext, textgroup.el_3, UsedFont, italic, prop, height, tpos, longshort, plgroup.el_1, plgroup.el_2, posmeas, sel )
       case "angle3points":
             ele = measure_angle3points ( control_set, textgroup.el_2, toltext, textgroup.el_3, UsedFont, italic, prop, height, tpos, longshort, plgroup.el_1, plgroup.el_2, plgroup.el_3, posmeas )
       case "anglesector":
             ele = measure_anglesector  ( control_set, textgroup.el_2, toltext, textgroup.el_3, UsedFont, italic, prop, height, tpos, longshort, plgroup.el_1, posmeas )
       case "anglesector":
             ele = measure_arclength    ( control_set, textgroup.el_2, toltext, textgroup.el_3, UsedFont, italic, prop, height, tpos, longshort, plgroup.el_1, posmeas )
       end
    else
       switch type
       case "angle2lines":
             ele = measure_angle2lines  ( control_set, textgroup.el_2, toltext, textgroup.el_3, height, tpos, longshort, plgroup.el_1, plgroup.el_2, posmeas, sel )
       case "angle3points":
             ele = measure_angle3points ( control_set, textgroup.el_2, toltext, textgroup.el_3, height, tpos, longshort, plgroup.el_1, plgroup.el_2, plgroup.el_3, posmeas )
       case "anglesector":
             ele = measure_anglesector  ( control_set, textgroup.el_2, toltext, textgroup.el_3, height, tpos, longshort, plgroup.el_1, posmeas )
       case "anglesector":
             ele = measure_arclength    ( control_set, textgroup.el_2, toltext, textgroup.el_3, height, tpos, longshort, plgroup.el_1, posmeas )
       end
    end
end

/* ====================================================================== */
function DTCreateSpline ( z, linestylegroup, art, grad, points, blanked, colnumber, infogroup )
    switch art
    case "nonper_urbs"   :
         ele = spline_nonper_urbs ( z, linestylegroup, grad, points )
    case "periodic_urbs" :
         ele = spline_periodic_urbs ( z, linestylegroup, grad, points )
    end
    if valid (ele) then
        DTSetColor   ( ele, colnumber )
        DTSetVisible ( ele, blanked )
        DTSetInfo    ( ele, infogroup )
    end
    return (ele)
end

/* ====================================================================== */
function DTCreateGroup ( name, elementgroup, blanked, colnumber, infogroup )
    if ObdVersion >= 5 then
        ele = group_create ( elementgroup, name )
    else
        ele = group_abs ( name, elementgroup )
    end
    DTSetColor   ( ele, colnumber )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreatePlane ( z, fillstyle, elementgroup, dist, angle, blanked, colgroup, infogroup )
    ele = plane_ofelements ( z, colgroup.el_1, fillstyle, elementgroup, dist, angle )
    DTSetColor   ( ele, colgroup )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end

/* ====================================================================== */
function DTCreatePlaneOfContour ( z, fillstyle, ele_contour, dist, angle, blanked, colgroup, infogroup )
    ele = plane_ofcontour ( z, colgroup.el_1, fillstyle, ele_contour, dist, angle )
    DTSetColor   ( ele, colgroup )
    DTSetVisible ( ele, blanked )
    DTSetInfo    ( ele, infogroup )
    return (ele)
end
