#!/bin/sh
#
# ******************************************************
# *****             COPYRIGHT  (C)  2000           *****
# *****         CCS Informationssysteme GmbH       *****
# *****              ALL RIGHTS RESERVED           *****
# ******************************************************
#
# DESCRIPTION:
#   Execute I-DEAS Variant Engineering.
#   This is run from the Family menu in the PDF (ideas.pdf).
#
# **********************
# *** Set stack size ***
# **********************
  SDRC_STACKSZ=0
  export SDRC_STACKSZ
# *****************
# *** Set umask ***
# *****************
#
  umask_save=`umask`
  umask 000
#
# ********************************************************
# *** Define environmental variables for EUKLID Design ***
# ********************************************************
#
  if [ ! "$SDRC_INSTL" ]
  then
     echo "engine:\n"
     echo "Installation variable SDRC_INSTL is not set."
  else
#
     : ${IDEAS_PARAM2:=$SDRC_INSTL/ideas}
     : ${SDRC_SEC:=$SDRC_INSTL/sec}
     : ${SDRC_IP:=$SDRC_INSTL/ip}
     : ${SDRC_PEC:=$SDRC_INSTL/ideas}
#
     export IDEAS_PARAM2 SDRC_SEC SDRC_IP SDRC_PEC
##
     if [ ! "$SDRC_ENG" ]
     then
        : ${SDRC_ENG:=/opt/konsys/euklid_design/2001}
        export SDRC_ENG
     fi

     if test ! -d $SDRC_ENG
     then
        echo "engine:\n"
        echo "EUKLID Design Installation directory does not exist:"
        echo "SDRC_ENG = "$SDRC_ENG
        exit
     else
        if test ! -d $SDRC_ENG/design
        then
           echo "engine:\n"
           echo "EUKLID Design Installation directory does not exist:"
           echo "SDRC_ENG = "$SDRC_ENG/design
           exit
        fi
     fi
#
# **********************
# *** Save IDEASCGD1 ***
# **********************
     SAVECGD1=$IDEASCGD1
     IDEASCGD1=
     export SAVECGD1 IDEASCGD1
#
#
# *************************
# *** Run EUKLID Design ***
# *************************
#

   if [ -f $SDRC_ENG/d2.exe ] 
   then
      cmd="$SDRC_ENG/d2.exe "
   else
      echo "Fatal Error detected: $SDRC_ENG/d2.exe not found"
      exit
   fi
   echo "start $cmd"
   $cmd

# *********************
# *** Restore umask ***
# *********************
#
     umask $umask_save
#
  fi
#
# **************************************
# *** If PSF found, return to I-DEAS ***
# **************************************
  if [ -f "$IDEASPSF" ]
  then
    echo ""
    echo "Returning to I-DEAS..."
    echo ""
    echo "#!/bin/sh" > exec${IDEASTPN}.cmd
    echo "$SDRC_PEC/pecrtn.exe " >> exec${IDEASTPN}.cmd
  fi
#
  exit
#

